"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.__RewireAPI__ = exports.__ResetDependency__ = exports.__set__ = exports.__Rewire__ = exports.__GetDependency__ = exports.__get__ = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _templateObject = _taggedTemplateLiteral(["padding: 0rem !important;"], ["padding: 0rem !important;"]),
    _templateObject2 = _taggedTemplateLiteral(["\n  padding: 1rem 1.6rem !important;\n  font-size: 0.8rem !important;\n  font-weight: 600 !important;\n  word-break: break-all !important;\n  background-color: #fff;\n"], ["\n  padding: 1rem 1.6rem !important;\n  font-size: 0.8rem !important;\n  font-weight: 600 !important;\n  word-break: break-all !important;\n  background-color: #fff;\n"]),
    _templateObject3 = _taggedTemplateLiteral(["\n  color: #fff;\n  width: 100%;\n  padding: 0.75rem;\n"], ["\n  color: #fff;\n  width: 100%;\n  padding: 0.75rem;\n"]),
    _templateObject4 = _taggedTemplateLiteral(["\n  cursor: pointer;\n  padding: 1.5rem 2.5rem;\n  background-color: #000;\n  border-radius: 0.5rem;\n  font-size: 0.8rem !important;\n"], ["\n  cursor: pointer;\n  padding: 1.5rem 2.5rem;\n  background-color: #000;\n  border-radius: 0.5rem;\n  font-size: 0.8rem !important;\n"]);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Card = require("material-ui/Card");

var _Paper = require("material-ui/Paper");

var _Paper2 = _interopRequireDefault(_Paper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var CardContent = _get__("styled")(_get__("MuiCardContent"))(_templateObject);

var SubTitle = _get__("styled")(_get__("MuiPaper"))(_templateObject2);

var Full = _get__("styled").div(_templateObject3);

var Board = _get__("styled").div(_templateObject4);

var ExampleValue = function ExampleValue(typeName) {
  switch (typeName) {
    case "Int":
      return _get__("React").createElement(
        "span",
        null,
        "1 "
      );
    case "Boolean":
      return _get__("React").createElement(
        "span",
        null,
        "true "
      );
    case "String":
      return _get__("React").createElement(
        "span",
        null,
        "\"",
        "foo",
        "\""
      );
    default:
      return _get__("React").createElement(
        "span",
        null,
        "1 "
      );
  }
};

var _DefaultExportValue = function _DefaultExportValue(_ref) {
  var name = _ref.name,
      args = _ref.args,
      fields = _ref.fields,
      mutation = _ref.mutation;
  return _get__("React").createElement(
    _get__("CardContent"),
    null,
    _get__("React").createElement(
      _get__("SubTitle"),
      { elevation: 1 },
      "Example"
    ),
    _get__("React").createElement(
      _get__("Full"),
      null,
      _get__("React").createElement(
        "div",
        { title: "copy", className: "copyButton", "data-clipboard-target": "#copy_" + name },
        _get__("React").createElement(
          _get__("Board"),
          { id: "copy_" + name },
          _get__("React").createElement(
            "div",
            null,
            mutation ? "mutation _ {" : "{",
            " "
          ),
          _get__("React").createElement(
            "div",
            null,
            "\xA0\xA0\xA0\xA0",
            name,
            "\xA0",
            args.length === 0 ? "" : "(",
            args.map(function (item, index) {
              return _get__("React").createElement(
                "span",
                { key: item.name },
                index > 0 ? ", " : "",
                item.name,
                ":\xA0",
                _get__("ExampleValue")(item.type.name)
              );
            }),
            args.length === 0 ? "" : ")",
            "\xA0\xA0",
            _get__("React").createElement(
              "span",
              null,
              "{",
              " "
            )
          ),
          fields.map(function (item, index) {
            return _get__("React").createElement(
              "div",
              { key: item.name },
              "\xA0\xA0\xA0\xA0\xA0\xA0\xA0\xA0",
              item.name
            );
          }),
          _get__("React").createElement(
            "div",
            null,
            "\xA0\xA0\xA0\xA0",
            "}",
            " "
          ),
          _get__("React").createElement(
            "div",
            null,
            "}",
            " "
          )
        )
      )
    )
  );
};

exports.default = _DefaultExportValue;

function _getGlobalObject() {
  try {
    if (!!global) {
      return global;
    }
  } catch (e) {
    try {
      if (!!window) {
        return window;
      }
    } catch (e) {
      return this;
    }
  }
}

;
var _RewireModuleId__ = null;

function _getRewireModuleId__() {
  if (_RewireModuleId__ === null) {
    var globalVariable = _getGlobalObject();

    if (!globalVariable.__$$GLOBAL_REWIRE_NEXT_MODULE_ID__) {
      globalVariable.__$$GLOBAL_REWIRE_NEXT_MODULE_ID__ = 0;
    }

    _RewireModuleId__ = __$$GLOBAL_REWIRE_NEXT_MODULE_ID__++;
  }

  return _RewireModuleId__;
}

function _getRewireRegistry__() {
  var theGlobalVariable = _getGlobalObject();

  if (!theGlobalVariable.__$$GLOBAL_REWIRE_REGISTRY__) {
    theGlobalVariable.__$$GLOBAL_REWIRE_REGISTRY__ = Object.create(null);
  }

  return __$$GLOBAL_REWIRE_REGISTRY__;
}

function _getRewiredData__() {
  var moduleId = _getRewireModuleId__();

  var registry = _getRewireRegistry__();

  var rewireData = registry[moduleId];

  if (!rewireData) {
    registry[moduleId] = Object.create(null);
    rewireData = registry[moduleId];
  }

  return rewireData;
}

(function registerResetAll() {
  var theGlobalVariable = _getGlobalObject();

  if (!theGlobalVariable['__rewire_reset_all__']) {
    theGlobalVariable['__rewire_reset_all__'] = function () {
      theGlobalVariable.__$$GLOBAL_REWIRE_REGISTRY__ = Object.create(null);
    };
  }
})();

var INTENTIONAL_UNDEFINED = '__INTENTIONAL_UNDEFINED__';
var _RewireAPI__ = {};

(function () {
  function addPropertyToAPIObject(name, value) {
    Object.defineProperty(_RewireAPI__, name, {
      value: value,
      enumerable: false,
      configurable: true
    });
  }

  addPropertyToAPIObject('__get__', _get__);
  addPropertyToAPIObject('__GetDependency__', _get__);
  addPropertyToAPIObject('__Rewire__', _set__);
  addPropertyToAPIObject('__set__', _set__);
  addPropertyToAPIObject('__reset__', _reset__);
  addPropertyToAPIObject('__ResetDependency__', _reset__);
  addPropertyToAPIObject('__with__', _with__);
})();

function _get__(variableName) {
  var rewireData = _getRewiredData__();

  if (rewireData[variableName] === undefined) {
    return _get_original__(variableName);
  } else {
    var value = rewireData[variableName];

    if (value === INTENTIONAL_UNDEFINED) {
      return undefined;
    } else {
      return value;
    }
  }
}

function _get_original__(variableName) {
  switch (variableName) {
    case "styled":
      return _styledComponents2.default;

    case "MuiCardContent":
      return _Card.CardContent;

    case "MuiPaper":
      return _Paper2.default;

    case "ExampleValue":
      return ExampleValue;

    case "React":
      return _react2.default;

    case "CardContent":
      return CardContent;

    case "SubTitle":
      return SubTitle;

    case "Full":
      return Full;

    case "Board":
      return Board;
  }

  return undefined;
}

function _assign__(variableName, value) {
  var rewireData = _getRewiredData__();

  if (rewireData[variableName] === undefined) {
    return _set_original__(variableName, value);
  } else {
    return rewireData[variableName] = value;
  }
}

function _set_original__(variableName, _value) {
  switch (variableName) {}

  return undefined;
}

function _update_operation__(operation, variableName, prefix) {
  var oldValue = _get__(variableName);

  var newValue = operation === '++' ? oldValue + 1 : oldValue - 1;

  _assign__(variableName, newValue);

  return prefix ? newValue : oldValue;
}

function _set__(variableName, value) {
  var rewireData = _getRewiredData__();

  if ((typeof variableName === "undefined" ? "undefined" : _typeof(variableName)) === 'object') {
    Object.keys(variableName).forEach(function (name) {
      rewireData[name] = variableName[name];
    });
  } else {
    if (value === undefined) {
      rewireData[variableName] = INTENTIONAL_UNDEFINED;
    } else {
      rewireData[variableName] = value;
    }

    return function () {
      _reset__(variableName);
    };
  }
}

function _reset__(variableName) {
  var rewireData = _getRewiredData__();

  delete rewireData[variableName];

  if (Object.keys(rewireData).length == 0) {
    delete _getRewireRegistry__()[_getRewireModuleId__];
  }

  ;
}

function _with__(object) {
  var rewireData = _getRewiredData__();

  var rewiredVariableNames = Object.keys(object);
  var previousValues = {};

  function reset() {
    rewiredVariableNames.forEach(function (variableName) {
      rewireData[variableName] = previousValues[variableName];
    });
  }

  return function (callback) {
    rewiredVariableNames.forEach(function (variableName) {
      previousValues[variableName] = rewireData[variableName];
      rewireData[variableName] = object[variableName];
    });
    var result = callback();

    if (!!result && typeof result.then == 'function') {
      result.then(reset).catch(reset);
    } else {
      reset();
    }

    return result;
  };
}

var _typeOfOriginalExport = typeof _DefaultExportValue === "undefined" ? "undefined" : _typeof(_DefaultExportValue);

function addNonEnumerableProperty(name, value) {
  Object.defineProperty(_DefaultExportValue, name, {
    value: value,
    enumerable: false,
    configurable: true
  });
}

if ((_typeOfOriginalExport === 'object' || _typeOfOriginalExport === 'function') && Object.isExtensible(_DefaultExportValue)) {
  addNonEnumerableProperty('__get__', _get__);
  addNonEnumerableProperty('__GetDependency__', _get__);
  addNonEnumerableProperty('__Rewire__', _set__);
  addNonEnumerableProperty('__set__', _set__);
  addNonEnumerableProperty('__reset__', _reset__);
  addNonEnumerableProperty('__ResetDependency__', _reset__);
  addNonEnumerableProperty('__with__', _with__);
  addNonEnumerableProperty('__RewireAPI__', _RewireAPI__);
}

exports.__get__ = _get__;
exports.__GetDependency__ = _get__;
exports.__Rewire__ = _set__;
exports.__set__ = _set__;
exports.__ResetDependency__ = _reset__;
exports.__RewireAPI__ = _RewireAPI__;