"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.__RewireAPI__ = exports.__ResetDependency__ = exports.__set__ = exports.__Rewire__ = exports.__GetDependency__ = exports.__get__ = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _templateObject = _taggedTemplateLiteral(["\n  padding: 2rem 1rem;\n  background-color: #f9f9f9;\n"], ["\n  padding: 2rem 1rem;\n  background-color: #f9f9f9;\n"]),
    _templateObject2 = _taggedTemplateLiteral(["padding-bottom: 1rem;"], ["padding-bottom: 1rem;"]),
    _templateObject3 = _taggedTemplateLiteral(["\n  width: 50%;\n  padding 2.5rem 1rem;\n  font-weight: 600;\n\n  > span {\n    padding-left: 0.5rem;\n    color: red;\n    font-weight: 1;\n  }\n\n"], ["\n  width: 50%;\n  padding 2.5rem 1rem;\n  font-weight: 600;\n\n  > span {\n    padding-left: 0.5rem;\n    color: red;\n    font-weight: 1;\n  }\n\n"]),
    _templateObject4 = _taggedTemplateLiteral(["\n  width: 3rem;\n  heght: 3rem;\n  margin-right: 1rem;\n  background-color: #fff;\n  padding: 0 0.25rem;\n"], ["\n  width: 3rem;\n  heght: 3rem;\n  margin-right: 1rem;\n  background-color: #fff;\n  padding: 0 0.25rem;\n"]);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _AppBar = require("material-ui/AppBar");

var _AppBar2 = _interopRequireDefault(_AppBar);

var _Toolbar = require("material-ui/Toolbar");

var _Toolbar2 = _interopRequireDefault(_Toolbar);

var _Typography = require("material-ui/Typography");

var _Typography2 = _interopRequireDefault(_Typography);

var _Divider = require("material-ui/Divider");

var _Divider2 = _interopRequireDefault(_Divider);

var _Query = require("../Query");

var _Footer = require("../Footer");

var _Footer2 = _interopRequireDefault(_Footer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Frame = _get__("styled").div(_templateObject);

var Space = _get__("styled").div(_templateObject2);

var Endpoint = _get__("styled").div(_templateObject3);

var IconImg = _get__("styled").img(_templateObject4);

var _DefaultExportValue = function _DefaultExportValue(_ref) {
  var endpoint = _ref.endpoint,
      queries = _ref.queries,
      mutations = _ref.mutations;
  return _get__("React").createElement(
    "div",
    null,
    _get__("React").createElement(
      _get__("AppBar"),
      { position: "static", color: "accent" },
      _get__("React").createElement(
        _get__("Toolbar"),
        null,
        _get__("React").createElement(_get__("IconImg"), {
          src: "https://wheatandcat.github.io/graphql-ui/static/media/header.f9a3af7c.png",
          alt: "icon"
        }),
        _get__("React").createElement(
          _get__("Typography"),
          { type: "title", color: "inherit" },
          "GraphQL-UI"
        )
      )
    ),
    _get__("React").createElement(
      _get__("Endpoint"),
      null,
      "GraphQL Endpoint",
      _get__("React").createElement(
        "span",
        null,
        endpoint
      ),
      _get__("React").createElement(_get__("Divider"), null)
    ),
    _get__("React").createElement(_get__("Divider"), null),
    _get__("React").createElement(
      _get__("Frame"),
      null,
      _get__("React").createElement(
        "div",
        null,
        queries.map(function (_ref2) {
          var name = _ref2.name,
              description = _ref2.description,
              args = _ref2.args,
              type = _ref2.type,
              ofType = _ref2.ofType;
          return _get__("React").createElement(
            _get__("Space"),
            { key: name },
            _get__("React").createElement(_get__("Query"), {
              name: name,
              description: description,
              args: args || [],
              fields: type.fields || type.ofType.fields || []
            })
          );
        })
      ),
      _get__("React").createElement(
        "div",
        null,
        mutations.map(function (_ref3) {
          var name = _ref3.name,
              description = _ref3.description,
              args = _ref3.args,
              type = _ref3.type;
          return _get__("React").createElement(
            _get__("Space"),
            { key: name },
            _get__("React").createElement(_get__("MutationType"), {
              name: name,
              description: description,
              args: args || [],
              fields: type.fields || type.ofType.fields || []
            })
          );
        })
      )
    ),
    _get__("React").createElement(_get__("Divider"), null),
    _get__("React").createElement(_get__("Footer"), null)
  );
};

exports.default = _DefaultExportValue;

function _getGlobalObject() {
  try {
    if (!!global) {
      return global;
    }
  } catch (e) {
    try {
      if (!!window) {
        return window;
      }
    } catch (e) {
      return this;
    }
  }
}

;
var _RewireModuleId__ = null;

function _getRewireModuleId__() {
  if (_RewireModuleId__ === null) {
    var globalVariable = _getGlobalObject();

    if (!globalVariable.__$$GLOBAL_REWIRE_NEXT_MODULE_ID__) {
      globalVariable.__$$GLOBAL_REWIRE_NEXT_MODULE_ID__ = 0;
    }

    _RewireModuleId__ = __$$GLOBAL_REWIRE_NEXT_MODULE_ID__++;
  }

  return _RewireModuleId__;
}

function _getRewireRegistry__() {
  var theGlobalVariable = _getGlobalObject();

  if (!theGlobalVariable.__$$GLOBAL_REWIRE_REGISTRY__) {
    theGlobalVariable.__$$GLOBAL_REWIRE_REGISTRY__ = Object.create(null);
  }

  return __$$GLOBAL_REWIRE_REGISTRY__;
}

function _getRewiredData__() {
  var moduleId = _getRewireModuleId__();

  var registry = _getRewireRegistry__();

  var rewireData = registry[moduleId];

  if (!rewireData) {
    registry[moduleId] = Object.create(null);
    rewireData = registry[moduleId];
  }

  return rewireData;
}

(function registerResetAll() {
  var theGlobalVariable = _getGlobalObject();

  if (!theGlobalVariable['__rewire_reset_all__']) {
    theGlobalVariable['__rewire_reset_all__'] = function () {
      theGlobalVariable.__$$GLOBAL_REWIRE_REGISTRY__ = Object.create(null);
    };
  }
})();

var INTENTIONAL_UNDEFINED = '__INTENTIONAL_UNDEFINED__';
var _RewireAPI__ = {};

(function () {
  function addPropertyToAPIObject(name, value) {
    Object.defineProperty(_RewireAPI__, name, {
      value: value,
      enumerable: false,
      configurable: true
    });
  }

  addPropertyToAPIObject('__get__', _get__);
  addPropertyToAPIObject('__GetDependency__', _get__);
  addPropertyToAPIObject('__Rewire__', _set__);
  addPropertyToAPIObject('__set__', _set__);
  addPropertyToAPIObject('__reset__', _reset__);
  addPropertyToAPIObject('__ResetDependency__', _reset__);
  addPropertyToAPIObject('__with__', _with__);
})();

function _get__(variableName) {
  var rewireData = _getRewiredData__();

  if (rewireData[variableName] === undefined) {
    return _get_original__(variableName);
  } else {
    var value = rewireData[variableName];

    if (value === INTENTIONAL_UNDEFINED) {
      return undefined;
    } else {
      return value;
    }
  }
}

function _get_original__(variableName) {
  switch (variableName) {
    case "styled":
      return _styledComponents2.default;

    case "React":
      return _react2.default;

    case "AppBar":
      return _AppBar2.default;

    case "Toolbar":
      return _Toolbar2.default;

    case "IconImg":
      return IconImg;

    case "Typography":
      return _Typography2.default;

    case "Endpoint":
      return Endpoint;

    case "Divider":
      return _Divider2.default;

    case "Frame":
      return Frame;

    case "Space":
      return Space;

    case "Query":
      return _Query.Query;

    case "MutationType":
      return _Query.MutationType;

    case "Footer":
      return _Footer2.default;
  }

  return undefined;
}

function _assign__(variableName, value) {
  var rewireData = _getRewiredData__();

  if (rewireData[variableName] === undefined) {
    return _set_original__(variableName, value);
  } else {
    return rewireData[variableName] = value;
  }
}

function _set_original__(variableName, _value) {
  switch (variableName) {}

  return undefined;
}

function _update_operation__(operation, variableName, prefix) {
  var oldValue = _get__(variableName);

  var newValue = operation === '++' ? oldValue + 1 : oldValue - 1;

  _assign__(variableName, newValue);

  return prefix ? newValue : oldValue;
}

function _set__(variableName, value) {
  var rewireData = _getRewiredData__();

  if ((typeof variableName === "undefined" ? "undefined" : _typeof(variableName)) === 'object') {
    Object.keys(variableName).forEach(function (name) {
      rewireData[name] = variableName[name];
    });
  } else {
    if (value === undefined) {
      rewireData[variableName] = INTENTIONAL_UNDEFINED;
    } else {
      rewireData[variableName] = value;
    }

    return function () {
      _reset__(variableName);
    };
  }
}

function _reset__(variableName) {
  var rewireData = _getRewiredData__();

  delete rewireData[variableName];

  if (Object.keys(rewireData).length == 0) {
    delete _getRewireRegistry__()[_getRewireModuleId__];
  }

  ;
}

function _with__(object) {
  var rewireData = _getRewiredData__();

  var rewiredVariableNames = Object.keys(object);
  var previousValues = {};

  function reset() {
    rewiredVariableNames.forEach(function (variableName) {
      rewireData[variableName] = previousValues[variableName];
    });
  }

  return function (callback) {
    rewiredVariableNames.forEach(function (variableName) {
      previousValues[variableName] = rewireData[variableName];
      rewireData[variableName] = object[variableName];
    });
    var result = callback();

    if (!!result && typeof result.then == 'function') {
      result.then(reset).catch(reset);
    } else {
      reset();
    }

    return result;
  };
}

var _typeOfOriginalExport = typeof _DefaultExportValue === "undefined" ? "undefined" : _typeof(_DefaultExportValue);

function addNonEnumerableProperty(name, value) {
  Object.defineProperty(_DefaultExportValue, name, {
    value: value,
    enumerable: false,
    configurable: true
  });
}

if ((_typeOfOriginalExport === 'object' || _typeOfOriginalExport === 'function') && Object.isExtensible(_DefaultExportValue)) {
  addNonEnumerableProperty('__get__', _get__);
  addNonEnumerableProperty('__GetDependency__', _get__);
  addNonEnumerableProperty('__Rewire__', _set__);
  addNonEnumerableProperty('__set__', _set__);
  addNonEnumerableProperty('__reset__', _reset__);
  addNonEnumerableProperty('__ResetDependency__', _reset__);
  addNonEnumerableProperty('__with__', _with__);
  addNonEnumerableProperty('__RewireAPI__', _RewireAPI__);
}

exports.__get__ = _get__;
exports.__GetDependency__ = _get__;
exports.__Rewire__ = _set__;
exports.__set__ = _set__;
exports.__ResetDependency__ = _reset__;
exports.__RewireAPI__ = _RewireAPI__;