"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.__RewireAPI__ = exports.__ResetDependency__ = exports.__set__ = exports.__Rewire__ = exports.__GetDependency__ = exports.__get__ = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _react3 = require("@storybook/react");

var _addonKnobs = require("@storybook/addon-knobs");

var _header = require("./header.png");

var _header2 = _interopRequireDefault(_header);

var _ = require("./");

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_get__("storiesOf")("Page", module).addDecorator(_get__("withKnobs")).add("Icon", function () {
  return _get__("React").createElement("img", { src: _get__("Icon"), alt: "icon" });
}).add("Page", function () {
  return _get__("React").createElement(_get__("Page"), {
    endpoint: "http://localhost:8080/graphql",
    queries: [{
      args: [{
        name: "id",
        type: {
          name: "Int"
        }
      }],
      description: "find contribution",
      name: "contribution",
      type: {
        fields: [{
          description: "created date",
          name: "createdAt",
          type: {
            name: "String"
          }
        }, {
          description: "delete date",
          name: "deletedAt",
          type: {
            name: "String"
          }
        }, {
          description: "id",
          name: "id",
          type: {
            name: "Int"
          }
        }, {
          description: "title",
          name: "title",
          type: {
            name: "String"
          }
        }, {
          description: "update date",
          name: "updatedAt",
          type: {
            name: "String"
          }
        }, {
          description: "user id",
          name: "userId",
          type: {
            name: "Int"
          }
        }, {
          description: "view status 0 ore 1",
          name: "viewStatus",
          type: {
            name: "Int"
          }
        }],
        name: "Contribution",
        ofType: null
      }
    }, {
      args: [{
        name: "first",
        type: {
          name: "Int"
        }
      }],
      description: "contribution list",
      name: "contributionList",
      type: {
        fields: null,
        name: null,
        ofType: {
          fields: [{
            description: "created date",
            name: "createdAt",
            type: {
              name: "String"
            }
          }, {
            description: "delete date",
            name: "deletedAt",
            type: {
              name: "String"
            }
          }, {
            description: "id",
            name: "id",
            type: {
              name: "Int"
            }
          }, {
            description: "title",
            name: "title",
            type: {
              name: "String"
            }
          }, {
            description: "update date",
            name: "updatedAt",
            type: {
              name: "String"
            }
          }, {
            description: "user id",
            name: "userId",
            type: {
              name: "Int"
            }
          }, {
            description: "view status 0 ore 1",
            name: "viewStatus",
            type: {
              name: "Int"
            }
          }],
          name: "Contribution"
        }
      }
    }, {
      args: [{
        name: "first",
        type: {
          name: "Int"
        }
      }],
      description: "proble list",
      name: "problemList",
      type: {
        fields: null,
        name: null,
        ofType: {
          fields: [{
            description: "created date",
            name: "createdAt",
            type: {
              name: "String"
            }
          }, {
            description: "delete date",
            name: "deletedAt",
            type: {
              name: "String"
            }
          }, {
            description: "id",
            name: "id",
            type: {
              name: "Int"
            }
          }, {
            description: "title",
            name: "title",
            type: {
              name: "String"
            }
          }, {
            description: "type",
            name: "type",
            type: {
              name: "Int"
            }
          }, {
            description: "update date",
            name: "updatedAt",
            type: {
              name: "String"
            }
          }, {
            description: "contribution id",
            name: "userContributionId",
            type: {
              name: "Int"
            }
          }, {
            description: "user id",
            name: "userId",
            type: {
              name: "Int"
            }
          }],
          name: "Contribution"
        }
      }
    }, {
      args: [{
        name: "first",
        type: {
          name: "Int"
        }
      }],
      description: "question list",
      name: "questionList",
      type: {
        fields: null,
        name: null,
        ofType: {
          fields: [{
            description: "body",
            name: "body",
            type: {
              name: "String"
            }
          }, {
            description: "created date",
            name: "createdAt",
            type: {
              name: "String"
            }
          }, {
            description: "delete date",
            name: "deletedAt",
            type: {
              name: "String"
            }
          }, {
            description: "email",
            name: "email",
            type: {
              name: "String"
            }
          }, {
            description: "id",
            name: "id",
            type: {
              name: "Int"
            }
          }, {
            description: "update date",
            name: "updatedAt",
            type: {
              name: "String"
            }
          }, {
            description: "user id",
            name: "userId",
            type: {
              name: "Int"
            }
          }],
          name: "Contribution"
        }
      }
    }, {
      args: [{
        name: "id",
        type: {
          name: "Int"
        }
      }],
      description: "find user",
      name: "user",
      type: {
        fields: [{
          description: "created date",
          name: "createdAt",
          type: {
            name: "String"
          }
        }, {
          description: "delete date",
          name: "deletedAt",
          type: {
            name: "String"
          }
        }, {
          description: "email",
          name: "email",
          type: {
            name: "String"
          }
        }, {
          description: "id",
          name: "id",
          type: {
            name: "Int"
          }
        }, {
          description: "name",
          name: "name",
          type: {
            name: "String"
          }
        }, {
          description: "profile image id",
          name: "profileImageId",
          type: {
            name: "Int"
          }
        }, {
          description: "update date",
          name: "updatedAt",
          type: {
            name: "String"
          }
        }],
        name: "User",
        ofType: null
      }
    }, {
      args: [{
        name: "first",
        type: {
          name: "Int"
        }
      }],
      description: "user list",
      name: "userList",
      type: {
        fields: null,
        name: null,
        ofType: {
          fields: [{
            description: "created date",
            name: "createdAt",
            type: {
              name: "String"
            }
          }, {
            description: "delete date",
            name: "deletedAt",
            type: {
              name: "String"
            }
          }, {
            description: "email",
            name: "email",
            type: {
              name: "String"
            }
          }, {
            description: "id",
            name: "id",
            type: {
              name: "Int"
            }
          }, {
            description: "name",
            name: "name",
            type: {
              name: "String"
            }
          }, {
            description: "profile image id",
            name: "profileImageId",
            type: {
              name: "Int"
            }
          }, {
            description: "update date",
            name: "updatedAt",
            type: {
              name: "String"
            }
          }],
          name: "User"
        }
      }
    }],
    mutations: [{
      args: [{
        description: "contribution id",
        name: "id",
        type: {
          name: "Int"
        }
      }],
      description: "Update existing todo, mark it done or not done",
      name: "hideContribution",
      type: {
        fields: [{
          description: "id",
          name: "id",
          type: {
            name: "Int"
          }
        }],
        name: "Hide",
        ofType: null
      }
    }, {
      args: [{
        description: "contribution id",
        name: "id",
        type: {
          name: "Int"
        }
      }],
      description: "Update existing todo, mark it done or not done",
      name: "showContribution",
      type: {
        fields: [{
          description: "id",
          name: "id",
          type: {
            name: "Int"
          }
        }],
        name: "Hide",
        ofType: null
      }
    }]
  });
});

function _getGlobalObject() {
  try {
    if (!!global) {
      return global;
    }
  } catch (e) {
    try {
      if (!!window) {
        return window;
      }
    } catch (e) {
      return this;
    }
  }
}

;
var _RewireModuleId__ = null;

function _getRewireModuleId__() {
  if (_RewireModuleId__ === null) {
    var globalVariable = _getGlobalObject();

    if (!globalVariable.__$$GLOBAL_REWIRE_NEXT_MODULE_ID__) {
      globalVariable.__$$GLOBAL_REWIRE_NEXT_MODULE_ID__ = 0;
    }

    _RewireModuleId__ = __$$GLOBAL_REWIRE_NEXT_MODULE_ID__++;
  }

  return _RewireModuleId__;
}

function _getRewireRegistry__() {
  var theGlobalVariable = _getGlobalObject();

  if (!theGlobalVariable.__$$GLOBAL_REWIRE_REGISTRY__) {
    theGlobalVariable.__$$GLOBAL_REWIRE_REGISTRY__ = Object.create(null);
  }

  return __$$GLOBAL_REWIRE_REGISTRY__;
}

function _getRewiredData__() {
  var moduleId = _getRewireModuleId__();

  var registry = _getRewireRegistry__();

  var rewireData = registry[moduleId];

  if (!rewireData) {
    registry[moduleId] = Object.create(null);
    rewireData = registry[moduleId];
  }

  return rewireData;
}

(function registerResetAll() {
  var theGlobalVariable = _getGlobalObject();

  if (!theGlobalVariable['__rewire_reset_all__']) {
    theGlobalVariable['__rewire_reset_all__'] = function () {
      theGlobalVariable.__$$GLOBAL_REWIRE_REGISTRY__ = Object.create(null);
    };
  }
})();

var INTENTIONAL_UNDEFINED = '__INTENTIONAL_UNDEFINED__';
var _RewireAPI__ = {};

(function () {
  function addPropertyToAPIObject(name, value) {
    Object.defineProperty(_RewireAPI__, name, {
      value: value,
      enumerable: false,
      configurable: true
    });
  }

  addPropertyToAPIObject('__get__', _get__);
  addPropertyToAPIObject('__GetDependency__', _get__);
  addPropertyToAPIObject('__Rewire__', _set__);
  addPropertyToAPIObject('__set__', _set__);
  addPropertyToAPIObject('__reset__', _reset__);
  addPropertyToAPIObject('__ResetDependency__', _reset__);
  addPropertyToAPIObject('__with__', _with__);
})();

function _get__(variableName) {
  var rewireData = _getRewiredData__();

  if (rewireData[variableName] === undefined) {
    return _get_original__(variableName);
  } else {
    var value = rewireData[variableName];

    if (value === INTENTIONAL_UNDEFINED) {
      return undefined;
    } else {
      return value;
    }
  }
}

function _get_original__(variableName) {
  switch (variableName) {
    case "storiesOf":
      return _react3.storiesOf;

    case "withKnobs":
      return _addonKnobs.withKnobs;

    case "Icon":
      return _header2.default;

    case "React":
      return _react2.default;

    case "Page":
      return _2.default;
  }

  return undefined;
}

function _assign__(variableName, value) {
  var rewireData = _getRewiredData__();

  if (rewireData[variableName] === undefined) {
    return _set_original__(variableName, value);
  } else {
    return rewireData[variableName] = value;
  }
}

function _set_original__(variableName, _value) {
  switch (variableName) {}

  return undefined;
}

function _update_operation__(operation, variableName, prefix) {
  var oldValue = _get__(variableName);

  var newValue = operation === '++' ? oldValue + 1 : oldValue - 1;

  _assign__(variableName, newValue);

  return prefix ? newValue : oldValue;
}

function _set__(variableName, value) {
  var rewireData = _getRewiredData__();

  if ((typeof variableName === "undefined" ? "undefined" : _typeof(variableName)) === 'object') {
    Object.keys(variableName).forEach(function (name) {
      rewireData[name] = variableName[name];
    });
  } else {
    if (value === undefined) {
      rewireData[variableName] = INTENTIONAL_UNDEFINED;
    } else {
      rewireData[variableName] = value;
    }

    return function () {
      _reset__(variableName);
    };
  }
}

function _reset__(variableName) {
  var rewireData = _getRewiredData__();

  delete rewireData[variableName];

  if (Object.keys(rewireData).length == 0) {
    delete _getRewireRegistry__()[_getRewireModuleId__];
  }

  ;
}

function _with__(object) {
  var rewireData = _getRewiredData__();

  var rewiredVariableNames = Object.keys(object);
  var previousValues = {};

  function reset() {
    rewiredVariableNames.forEach(function (variableName) {
      rewireData[variableName] = previousValues[variableName];
    });
  }

  return function (callback) {
    rewiredVariableNames.forEach(function (variableName) {
      previousValues[variableName] = rewireData[variableName];
      rewireData[variableName] = object[variableName];
    });
    var result = callback();

    if (!!result && typeof result.then == 'function') {
      result.then(reset).catch(reset);
    } else {
      reset();
    }

    return result;
  };
}

exports.__get__ = _get__;
exports.__GetDependency__ = _get__;
exports.__Rewire__ = _set__;
exports.__set__ = _set__;
exports.__ResetDependency__ = _reset__;
exports.__RewireAPI__ = _RewireAPI__;
exports.default = _RewireAPI__;