"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.__RewireAPI__ = exports.__ResetDependency__ = exports.__set__ = exports.__Rewire__ = exports.__GetDependency__ = exports.__get__ = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _templateObject = _taggedTemplateLiteral(["\n  background-color: #e9f1fa !important;\n  border-radius: 0.5rem !important;\n  border: 0.1rem solid #56a6fe !important;\n  width: 100% !important;\n"], ["\n  background-color: #e9f1fa !important;\n  border-radius: 0.5rem !important;\n  border: 0.1rem solid #56a6fe !important;\n  width: 100% !important;\n"]),
    _templateObject2 = _taggedTemplateLiteral(["color: #808080;"], ["color: #808080;"]),
    _templateObject3 = _taggedTemplateLiteral(["color: red;"], ["color: red;"]),
    _templateObject4 = _taggedTemplateLiteral(["\n  padding: 0.3rem 1rem;\n  border-radius: 0.5rem;\n  background-color: #61affe;\n  color: #fff;\n  font-weight: 600;\n  word-break: break-all;\n  font-size: 0.8rem;\n  text-transform: uppercase;\n"], ["\n  padding: 0.3rem 1rem;\n  border-radius: 0.5rem;\n  background-color: #61affe;\n  color: #fff;\n  font-weight: 600;\n  word-break: break-all;\n  font-size: 0.8rem;\n  text-transform: uppercase;\n"]),
    _templateObject5 = _taggedTemplateLiteral(["\n  width: 100%;\n  text-align: left !important;\n  justify-content: start !important;\n  text-transform: none !important;\n  font-weight: 600 !important;\n  word-break: break-all !important;\n  font-size: 1rem !important;\n"], ["\n  width: 100%;\n  text-align: left !important;\n  justify-content: start !important;\n  text-transform: none !important;\n  font-weight: 600 !important;\n  word-break: break-all !important;\n  font-size: 1rem !important;\n"]),
    _templateObject6 = _taggedTemplateLiteral(["padding: 0rem !important;"], ["padding: 0rem !important;"]),
    _templateObject7 = _taggedTemplateLiteral(["\n  color: #343947;\n  font-weight: 1 !important;\n  padding: 0rem 1.5rem !important;\n  font-size: 1rem !important;\n"], ["\n  color: #343947;\n  font-weight: 1 !important;\n  padding: 0rem 1.5rem !important;\n  font-size: 1rem !important;\n"]),
    _templateObject8 = _taggedTemplateLiteral(["\n  padding: 0rem !important;\n  height: 3rem !important;\n"], ["\n  padding: 0rem !important;\n  height: 3rem !important;\n"]),
    _templateObject9 = _taggedTemplateLiteral(["display: none;"], ["display: none;"]);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Card = require("material-ui/Card");

var _Card2 = _interopRequireDefault(_Card);

var _Collapse = require("material-ui/transitions/Collapse");

var _Collapse2 = _interopRequireDefault(_Collapse);

var _Button = require("material-ui/Button");

var _Button2 = _interopRequireDefault(_Button);

var _Divider = require("material-ui/Divider");

var _Divider2 = _interopRequireDefault(_Divider);

var _ = require("./");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Card = _get__("styled")(_get__("MuiCard"))(_templateObject);

var ParamName = _get__("styled").span(_templateObject2);
var ParamType = _get__("styled").span(_templateObject3);

var QueryType = _get__("styled").span(_templateObject4);

var SchemeButton = _get__("styled")(_get__("MuiButton"))(_templateObject5);

var CardContent = _get__("styled")(_get__("MuiCardContent"))(_templateObject6);

var Description = _get__("styled").span(_templateObject7);

var CardActions = _get__("styled")(_get__("MuiCardActions"))(_templateObject8);

var Collapse = _get__("styled")(_get__("MuiCollapse"))(_templateObject9);

var _DefaultExportValue = function _DefaultExportValue(_ref) {
  var description = _ref.description,
      name = _ref.name,
      args = _ref.args,
      fields = _ref.fields,
      open = _ref.open;
  return _get__("React").createElement(
    _get__("Card"),
    null,
    _get__("React").createElement(
      _get__("CardActions"),
      { disableActionSpacing: true, className: "head" },
      _get__("React").createElement(
        _get__("SchemeButton"),
        null,
        _get__("React").createElement(
          _get__("QueryType"),
          null,
          "QUERYTYPE"
        ),
        "\xA0\xA0",
        name,
        "\xA0",
        args.length === 0 ? "" : "(",
        args.map(function (item, index) {
          return _get__("React").createElement(
            "span",
            { key: item.name },
            index > 0 ? ", " : "",
            _get__("React").createElement(
              _get__("ParamName"),
              null,
              item.name
            ),
            ":\xA0",
            _get__("React").createElement(
              _get__("ParamType"),
              null,
              item.type.name || "any"
            )
          );
        }),
        args.length === 0 ? "" : ")",
        _get__("React").createElement(
          _get__("Description"),
          null,
          description
        )
      )
    ),
    _get__("React").createElement(
      _get__("Collapse"),
      { "in": true, transitionDuration: "auto", unmountOnExit: true, className: "row" },
      _get__("React").createElement(_get__("Divider"), null),
      _get__("React").createElement(_get__("CardContent"), null),
      _get__("React").createElement(_get__("Fields"), { description: "Arguments", fields: args }),
      _get__("React").createElement(_get__("Fields"), { description: "Fields", fields: fields }),
      _get__("React").createElement(_get__("Example"), { name: name, args: args, fields: fields })
    )
  );
};

exports.default = _DefaultExportValue;

function _getGlobalObject() {
  try {
    if (!!global) {
      return global;
    }
  } catch (e) {
    try {
      if (!!window) {
        return window;
      }
    } catch (e) {
      return this;
    }
  }
}

;
var _RewireModuleId__ = null;

function _getRewireModuleId__() {
  if (_RewireModuleId__ === null) {
    var globalVariable = _getGlobalObject();

    if (!globalVariable.__$$GLOBAL_REWIRE_NEXT_MODULE_ID__) {
      globalVariable.__$$GLOBAL_REWIRE_NEXT_MODULE_ID__ = 0;
    }

    _RewireModuleId__ = __$$GLOBAL_REWIRE_NEXT_MODULE_ID__++;
  }

  return _RewireModuleId__;
}

function _getRewireRegistry__() {
  var theGlobalVariable = _getGlobalObject();

  if (!theGlobalVariable.__$$GLOBAL_REWIRE_REGISTRY__) {
    theGlobalVariable.__$$GLOBAL_REWIRE_REGISTRY__ = Object.create(null);
  }

  return __$$GLOBAL_REWIRE_REGISTRY__;
}

function _getRewiredData__() {
  var moduleId = _getRewireModuleId__();

  var registry = _getRewireRegistry__();

  var rewireData = registry[moduleId];

  if (!rewireData) {
    registry[moduleId] = Object.create(null);
    rewireData = registry[moduleId];
  }

  return rewireData;
}

(function registerResetAll() {
  var theGlobalVariable = _getGlobalObject();

  if (!theGlobalVariable['__rewire_reset_all__']) {
    theGlobalVariable['__rewire_reset_all__'] = function () {
      theGlobalVariable.__$$GLOBAL_REWIRE_REGISTRY__ = Object.create(null);
    };
  }
})();

var INTENTIONAL_UNDEFINED = '__INTENTIONAL_UNDEFINED__';
var _RewireAPI__ = {};

(function () {
  function addPropertyToAPIObject(name, value) {
    Object.defineProperty(_RewireAPI__, name, {
      value: value,
      enumerable: false,
      configurable: true
    });
  }

  addPropertyToAPIObject('__get__', _get__);
  addPropertyToAPIObject('__GetDependency__', _get__);
  addPropertyToAPIObject('__Rewire__', _set__);
  addPropertyToAPIObject('__set__', _set__);
  addPropertyToAPIObject('__reset__', _reset__);
  addPropertyToAPIObject('__ResetDependency__', _reset__);
  addPropertyToAPIObject('__with__', _with__);
})();

function _get__(variableName) {
  var rewireData = _getRewiredData__();

  if (rewireData[variableName] === undefined) {
    return _get_original__(variableName);
  } else {
    var value = rewireData[variableName];

    if (value === INTENTIONAL_UNDEFINED) {
      return undefined;
    } else {
      return value;
    }
  }
}

function _get_original__(variableName) {
  switch (variableName) {
    case "styled":
      return _styledComponents2.default;

    case "MuiCard":
      return _Card2.default;

    case "MuiButton":
      return _Button2.default;

    case "MuiCardContent":
      return _Card.CardContent;

    case "MuiCardActions":
      return _Card.CardActions;

    case "MuiCollapse":
      return _Collapse2.default;

    case "React":
      return _react2.default;

    case "Card":
      return Card;

    case "CardActions":
      return CardActions;

    case "SchemeButton":
      return SchemeButton;

    case "QueryType":
      return QueryType;

    case "ParamName":
      return ParamName;

    case "ParamType":
      return ParamType;

    case "Description":
      return Description;

    case "Collapse":
      return Collapse;

    case "Divider":
      return _Divider2.default;

    case "CardContent":
      return CardContent;

    case "Fields":
      return _.Fields;

    case "Example":
      return _.Example;
  }

  return undefined;
}

function _assign__(variableName, value) {
  var rewireData = _getRewiredData__();

  if (rewireData[variableName] === undefined) {
    return _set_original__(variableName, value);
  } else {
    return rewireData[variableName] = value;
  }
}

function _set_original__(variableName, _value) {
  switch (variableName) {}

  return undefined;
}

function _update_operation__(operation, variableName, prefix) {
  var oldValue = _get__(variableName);

  var newValue = operation === '++' ? oldValue + 1 : oldValue - 1;

  _assign__(variableName, newValue);

  return prefix ? newValue : oldValue;
}

function _set__(variableName, value) {
  var rewireData = _getRewiredData__();

  if ((typeof variableName === "undefined" ? "undefined" : _typeof(variableName)) === 'object') {
    Object.keys(variableName).forEach(function (name) {
      rewireData[name] = variableName[name];
    });
  } else {
    if (value === undefined) {
      rewireData[variableName] = INTENTIONAL_UNDEFINED;
    } else {
      rewireData[variableName] = value;
    }

    return function () {
      _reset__(variableName);
    };
  }
}

function _reset__(variableName) {
  var rewireData = _getRewiredData__();

  delete rewireData[variableName];

  if (Object.keys(rewireData).length == 0) {
    delete _getRewireRegistry__()[_getRewireModuleId__];
  }

  ;
}

function _with__(object) {
  var rewireData = _getRewiredData__();

  var rewiredVariableNames = Object.keys(object);
  var previousValues = {};

  function reset() {
    rewiredVariableNames.forEach(function (variableName) {
      rewireData[variableName] = previousValues[variableName];
    });
  }

  return function (callback) {
    rewiredVariableNames.forEach(function (variableName) {
      previousValues[variableName] = rewireData[variableName];
      rewireData[variableName] = object[variableName];
    });
    var result = callback();

    if (!!result && typeof result.then == 'function') {
      result.then(reset).catch(reset);
    } else {
      reset();
    }

    return result;
  };
}

var _typeOfOriginalExport = typeof _DefaultExportValue === "undefined" ? "undefined" : _typeof(_DefaultExportValue);

function addNonEnumerableProperty(name, value) {
  Object.defineProperty(_DefaultExportValue, name, {
    value: value,
    enumerable: false,
    configurable: true
  });
}

if ((_typeOfOriginalExport === 'object' || _typeOfOriginalExport === 'function') && Object.isExtensible(_DefaultExportValue)) {
  addNonEnumerableProperty('__get__', _get__);
  addNonEnumerableProperty('__GetDependency__', _get__);
  addNonEnumerableProperty('__Rewire__', _set__);
  addNonEnumerableProperty('__set__', _set__);
  addNonEnumerableProperty('__reset__', _reset__);
  addNonEnumerableProperty('__ResetDependency__', _reset__);
  addNonEnumerableProperty('__with__', _with__);
  addNonEnumerableProperty('__RewireAPI__', _RewireAPI__);
}

exports.__get__ = _get__;
exports.__GetDependency__ = _get__;
exports.__Rewire__ = _set__;
exports.__set__ = _set__;
exports.__ResetDependency__ = _reset__;
exports.__RewireAPI__ = _RewireAPI__;